#!/bin/bash

# $1: localización del repositorio
# $2: directorio plataforma
# $3: lista de features

repo=$1
platformFolder=$2
listFeatures=$3

sufix=".feature.group"

echo "URL Repo: ${repo}"
echo "Platform location: ${platformFolder}"
echo "List of features to install: ${listFeatures}"

echo -e "\nCreating list of features\n"

   echo | awk -v lista=$listFeatures '{split(lista, v, ","); for(i in v) print v[i]}' > tempList

   while read line
   do
      featureString="${line}${sufix}"
      echo -n "${featureString}," >> tempFeatureString
   done < tempList

listOfFeatures=`cat tempFeatureString`

${HOME}/moskitt-galileo-dev/build/org.eclipse.releng.basebuilder/eclipse -application org.eclipse.equinox.p2.director \
-repository ${repo} \
-installIU ${listOfFeatures} \
-destination ${platformFolder} \
-bundlepool ${platformFolder} \
-vmargs -Dorg.eclipse.ecf.provider.filetransfer.excludeContributors= org.eclipse.ecf.provider.filetransfer.httpclient \
-Dhttp.proxyPort=8080 \
-Dhttp.proxyHost=193.145.204.53

echo -e "\nDeleting temporary files and folders\n"
   rm tempList
   rm tempFeatureString
