/*******************************************************************************
 * Copyright (c) 2008 The University of York.
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 * 
 * Contributors:
 *     Louis Rose - initial API and implementation
 ******************************************************************************/
package org.eclipse.epsilon.egl.parse;

public class RecognitionException extends Exception {

	// Generated by Eclipse
	private static final long serialVersionUID = -5527569663197109413L;
	
	private final int line;
	private final int col;
	
	public RecognitionException(String message, int line, int col) {
		super(message);
		this.line    = line;
		this.col     = col;
	}

	public int getColumnNumber() {
		return col;
	}

	public int getLineNumber() {
		return line;
	}
	
	@Override
	public String toString() {
		return getMessage() + " at line "+line + " col "+col;
	}
}
